#include <stdio.h>
#include <cstdlib>
#include <iostream>
#include <set>
#include <algorithm>
#include <vector>
#include <string>
#include <memory.h>
#include <map>
#define _USE_MATH_DEFINES
#include <math.h>
#include <list>
#include <fstream>
#include <time.h>
#include <iomanip>
#include <queue>
#include <stack>
using namespace std;
 
#define For(i,a,b,d) for (int i = (a); i != (b); i += d)
#define FORD(i,a,b) for (int i = (a); i >= b; i--)
#define FOR(i,a,b) for (int i = (a); i <= (b); i++)
#define REPD(i,n) for (int i = (n - 1); i >= 0; i--)
#define REP(i,n) for (int i = 0; i < (n); i++)
#define CLR(a,x) memset(a,x,sizeof(a))
#define pb push_back
#define mp make_pair
#define eps 10e-3
#define Inf 1000000000
#define Mi 1000000007
#define N 1001
#define K 11
//#define debug
 
typedef double ld;
typedef unsigned long long ll;
typedef int i;
typedef vector<i> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef pair<double, char> pdc;
typedef enum {heavy, light} lbl;
 
ll max (ll a, ll b) {if (a>b) return a; return b;}
int min (int a, int b) {if (a < b) return a; return b;}
int Abs(int a) {if (a < 0) return -a; else return a;}
ld Abs (ld a) {if (a < 0) return -a; else return a;}
int sqr (int a) {return a*a;}
 
struct TDP
{
    ll F[4][4];
};
 
TDP _one;
 
TDP merg (TDP a, TDP b)
{
    TDP res;
    CLR(res.F, 0);
    REP(i, 4) REP(j, 4) REP(k, 4) REP(l, 4)
        if (j != k) res.F[i][l] += (a.F[i][j] * b.F[k][l]) % Mi;
    return res;
}
 
TDP rec (ll k)
{
    if (k == 1) return _one;
    TDP res = rec (k / 2);
    res = merg (res, res);
    if (k & 1) res = merg (res, _one);
    return res;
}
 
#define ONLINE_JUDGE
int main ()
{
    #ifndef ONLINE_JUDGE
        freopen ("input.txt", "r", stdin);
        freopen ("output.txt", "w", stdout);
    #endif
    REP(i, 4) _one.F[i][i] = 1;
    int T;
    scanf ("%d", &T);
    while (T--)
    {
        ll n;
        cin >> n;
        TDP res = rec (n);
        ll ans = 0;
        REP(i, 4) REP(j, 4)
            if (i != j) ans = (ans + res.F[i][j]) % Mi;
        if (n == 1) ans = 4;
        cout << ans << endl;
    }
    return 0;
}
 
